<template>
    <div class="creategame">
        <Header title="Buzzword Bingo" msg="Spiel erstellen" title_right="" />

        <div class="container">
            <b-form @submit="onSubmit" v-if="show">
                <b-form-group
                    id="gamename-group"
                    label="Spielname:"
                    label-for="gamename"
                >
                    <b-form-input
                        id="gamename"
                        v-model="form.gamename"
                        type="text"
                        required
                        placeholder="Spielname eingeben"
                    ></b-form-input>
                </b-form-group>
                <b-form-group
                    id="nickname-group"
                    label="Nickname:"
                    label-for="nickname"
                >
                    <b-form-input
                        id="nickname"
                        v-model="form.nickname"
                        type="text"
                        required
                        placeholder="Nickname eingeben"
                    ></b-form-input>
                </b-form-group>
                <div class="form-group" role="group">
                    <label class="d-block">Spielstart:</label>
                    <date-pick
                        v-model="form.startdate"
                        :pickTime="true"
                        :format="dateFormat"
                        :parseDate="parseDate"
                        :formatDate="formatDate">
                    </date-pick>
                </div>
                <b-form-group
                        id="gametime-group"
                        label="Spieldauer"
                        label-for="gametime"
                >
                    <b-form-select
                            id="gametime"
                            v-model="form.gametime"
                            :options="gametimeOptions"
                    ></b-form-select>
                </b-form-group>
                <b-form-group
                    id="difficulty-group"
                    label="Schwierigkeit"
                    label-for="difficulty"
                    >
                    <b-form-select
                        id="difficulty"
                        v-model="form.difficulty"
                        :options="difficultyOptions"
                    ></b-form-select>
                </b-form-group>
                <b-form-group>
                    <b-form-checkbox
                        id="fullmap"
                        switch
                        v-model="form.needFullCard"
                    >Ganze Karte muss voll sein</b-form-checkbox>
                </b-form-group>
                <b-button type="submit" variant="primary">Spiel erstellen</b-button>
            </b-form>
        </div>
    </div>
</template>

<script>
    import Difficulty from '@/constants/difficulty';
    import Header from '@/components/Header.vue';
    import DatePick from 'vue-date-pick';
    import 'vue-date-pick/dist/vueDatePick.css';

    export default {
        components: {
            Header,
            DatePick
        },
        data: () => {
            return {
                form: {
                    gamename: '',
                    nickname: '',
                    startdate: null,
                    gametime: 5 * 60,
                    difficulty: Difficulty.EASY,
                    needFullCard: false,
                },
                difficultyOptions: [
                    { value: Difficulty.EASY, text: 'Einfach' },
                    { value: Difficulty.MEDIUM, text: 'Normal' },                    
                    { value: Difficulty.HEAVY, text: 'Schwer' },
                ],
                gametimeOptions: [
                    { value: 5 * 60, text: '5 Minuten' },
                    { value: 10 * 60, text: '10 Minuten' },
                    { value: 15 * 60, text: '15 Minuten' },
                    { value: 30 * 60, text: '30 Minuten' },
                    { value: 45 * 60, text: '45 Minuten' },
                    { value: 60 * 60, text: '1 Stunde' },
                ],
                show: true,
                dateFormat: 'LLL',
            }
        },
        // mounted must be a function() otherwise the method lookup of ecmascript will fail... :-@
        mounted: function() {
            this.init();
        },
        methods: {
            init: function () {
                this.$moment.locale('de')
                this.form.startdate = this.generateDate();
            },
            onSubmit: function (evt) {
                evt.preventDefault();
                // convert date to the backend format
                let isoStartDate = this.$moment(this.form.startdate, this.dateFormat).toDate().toISOString()
                let newGameRequest = {
                    gameDuration: this.form.gametime,
                    gameName: this.form.gamename,
                    gameStart: isoStartDate,
                    gamelevel: this.form.difficulty,
                    needFullCard: this.form.needFullCard,
                    nickName: this.form.nickname,
                }
                this.$store.dispatch('createGame', newGameRequest).then(res => {
                    this.$router.push('/startgame')
                }).catch(err => {
                })
            },
            generateDate: function () {
                return this.$moment().add(5, 'm').format(this.dateFormat)
            },
            parseDate(dateString, format) {
                let dateObj = this.$moment(dateString, format).toDate()
                return dateObj
            },
            formatDate(dateObj, format) {
                let dateFormatted = this.$moment(dateObj, format).format(format)
                return dateFormatted
            }
        }
    }
</script>

<style>
    .container {
        margin-top: 15px;
    }

    /* Fix styling */
    .vdpTimeUnit {
        width: 30px;
    }

    .vdpComponent {
        width: 100%;
    }

    .vdpComponent > input {
        display: block;
        width: 100%;
        height: calc(1.5em + 0.75rem + 2px);
        padding: 0.375rem 0.75rem;
        font-size: 1rem;
        font-weight: 400;
        line-height: 1.5;
        color: #495057;
        background-color: #fff;
        background-clip: padding-box;
        border: 1px solid #ced4da;
        border-radius: 0.25rem;
        -webkit-transition: border-color 0.15s ease-in-out, -webkit-box-shadow 0.15s ease-in-out;
        transition: border-color 0.15s ease-in-out, -webkit-box-shadow 0.15s ease-in-out;
        transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;
        transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out, -webkit-box-shadow 0.15s ease-in-out;
    }
</style>